function setUnicodePref(prefName,prefValue,prefBranch) {
    var sString = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
    sString.data = prefValue;
    prefBranch.setComplexValue(prefName,Components.interfaces.nsISupportsString,sString);
}

function onLoad() {

	var btnApply = document.documentElement.getButton("extra1");
	btnApply.label = "Apply";
	btnApply.addEventListener("click", onAccept, false);

	// load settings
	var pref = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch("extensions.tocyrillic.");	
	
	document.getElementById("tocyrillic-label").value = ToCyrillic.getUnicodePref("labels.tocyrillic", pref);
	document.getElementById("totranslit-label").value = ToCyrillic.getUnicodePref("labels.totranslit", pref);
	document.getElementById("togglemode-label").value = ToCyrillic.getUnicodePref("labels.togglemode", pref);
	
	document.getElementById("tocyrillic-shortcut").value = pref.getCharPref("shortcuts.tocyrillic");
	document.getElementById("totranslit-shortcut").value = pref.getCharPref("shortcuts.totranslit");
	document.getElementById("togglemode-shortcut").value = pref.getCharPref("shortcuts.togglemode");

	var childCount = new Object();
	var list = pref.getChildList("layouts.", childCount);
	var fullList = new Array();
	for (var i = 0; i < childCount.value; i++) {
		if (list[i].search(/layouts\.[^\.]+$/i) == 0) {
			var desc = list[i];
			var value = desc.replace(/layouts\./i, "");
			try {
				desc = ToCyrillic.getUnicodePref(list[i] + ".description", pref);
			} catch (e) {
			}
			fullList[fullList.length] = [desc,value];
			//menulist.appendItem(desc, value, "");
		}
	}
	//menulist.selectedIndex = 0;
	fullList.sort();
	var menulist = document.getElementById("layout-select");
	for (var i = 0; i < fullList.length; i++) {
		menulist.appendItem(fullList[i][0], fullList[i][1], "");
	}
	
	menulist.value = pref.getCharPref("layout");
	
	window.sizeToContent();
	
}


function shortcutKeyPress(event) {
	event.preventDefault();
	
	//if (event.keyCode == 0)
	//	return;
	
	var mods = "";
	if (event.altKey)
		mods += (mods == "" ? "" : "+") + "Alt";
	if (event.ctrlKey)
		mods += (mods == "" ? "" : "+") + "Ctrl";
	if (event.shiftKey)
		mods += (mods == "" ? "" : "+") + "Shift";
	if (event.metaKey)
		mods += (mods == "" ? "" : "+") + "Meta";
	
	var keyCode = event.keyCode? event.keyCode : String.fromCharCode(event.charCode).toLocaleUpperCase().charCodeAt(0);
	var code = "";
	//alert(keyCode);

	// figure out the vk_ code
	for (var i in event) {
		if (i.search(/DOM_VK_/i) == 0) 
			if (event[i] == keyCode) {
				code = i;
				break;
			}
	}
	code = code.replace(/DOM_/i, "");
		
	event.target.value = mods + (mods == "" ? "" : "+") + code;
}

function objToString(obj) {
	var s = "";
	for(var i in obj)
		//if ( ("" + i != ("" + i).toUpperCase()) &&
		//	  !(obj[i] instanceof Function))
		//if (obj[i] instanceof Function)
		//	s += i + ": function\n";
		//else
			s += i + " = " + obj[i] + "\n";
	return s;
}

function onAccept() {
	//save new settings

	var pref = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch("extensions.tocyrillic.");	

	if (document.getElementById("tocyrillic-label").value != ToCyrillic.getUnicodePref("labels.tocyrillic", pref))
		setUnicodePref("labels.tocyrillic", document.getElementById("tocyrillic-label").value, pref);
	
	if (document.getElementById("totranslit-label").value != ToCyrillic.getUnicodePref("labels.totranslit", pref))
		setUnicodePref("labels.totranslit", document.getElementById("totranslit-label").value, pref);
		
	if (document.getElementById("togglemode-label").value != ToCyrillic.getUnicodePref("labels.togglemode", pref))
		setUnicodePref("labels.togglemode", document.getElementById("togglemode-label").value, pref);
	
	if (document.getElementById("tocyrillic-shortcut").value != pref.getCharPref("shortcuts.tocyrillic"))
		pref.setCharPref("shortcuts.tocyrillic", document.getElementById("tocyrillic-shortcut").value);
		
	if (document.getElementById("totranslit-shortcut").value != pref.getCharPref("shortcuts.totranslit"))
		pref.setCharPref("shortcuts.totranslit", document.getElementById("totranslit-shortcut").value);
		
	if (document.getElementById("togglemode-shortcut").value != pref.getCharPref("shortcuts.togglemode"))
		pref.setCharPref("shortcuts.togglemode", document.getElementById("togglemode-shortcut").value);
		
	if (document.getElementById("layout-select").value != pref.getCharPref("layout"))
		pref.setCharPref("layout", document.getElementById("layout-select").value);
	
	return true;
}
