//tocyrillic extension. copyright alex benenson. use as you please, but let me know if you find any bugs
var ToCyrillic = {
newGecko : false,
conversionTable : undefined, 

conversionHash : undefined,
maxLatLength : 0,
maxCyrLength : 0,

getConversionHash: function () {
	if (ToCyrillic.conversionHash == undefined) {
		ToCyrillic.conversionHash = new Array();
		for (var i = 0; i < ToCyrillic.conversionTable.length; i++) {
			if (!ToCyrillic.conversionHash[ToCyrillic.conversionTable[i][0].toLocaleUpperCase()]) {
				ToCyrillic.conversionHash[ToCyrillic.conversionTable[i][0].toLocaleUpperCase()] = ToCyrillic.conversionTable[i].slice(1);
				ToCyrillic.maxLatLength = Math.max(ToCyrillic.maxLatLength, ToCyrillic.conversionTable[i][0].length);
			}
		}
	}
	return ToCyrillic.conversionHash;
},

to_cyrillic: function(src, output, chunks) {
	if (src == undefined || src == "" || src == null)
		return src;
	if (output == undefined)
		output = new String();

	var hash = ToCyrillic.getConversionHash();
	
	var location = 0;
	
	while (location < src.length) {
		var len = Math.min(ToCyrillic.maxLatLength, src.length - location);
		var arr = undefined;
		var sub;
		while (len > 0) {
			sub = src.substr(location, len);
			arr = hash[sub.toLocaleUpperCase()];
			if (arr != undefined) 
				break;
			else 
				len--;
		}
		
		// need this for translit on the fly
		if (chunks != undefined)
			chunks[chunks.length] = [sub, arr == undefined ? 0 : arr[0].length];
			
		if (arr == undefined) {
			output += sub;
			location ++;
		}
		else {
			// case analysis
			var newStr = arr[0];
			
			if (sub.toLocaleLowerCase() == sub.toLocaleUpperCase() && arr.length > 1 && arr[1] && (newStr.toLocaleUpperCase() != newStr.toLocaleLowerCase())) {
				// source is caseless, target is not caseless, guess case set to true - going to figure out the desired case for newStr
				
				// need translit hash to determine if previous character (and possibly the one before it) 
				// were converted and are in upper case
				
				// set prevDud to true previous is not a translated character or simply a blank
				// set prevCap to true if previous was translated and was upper case

				var prevCh = output.length == 0 ? null : output.substr(output.length - 1, 1);
				var prevDud = !prevCh || !ToCyrillic.getTranslitString(prevCh);
				var prevCap = (!prevDud && prevCh == prevCh.toLocaleUpperCase());

				// sub is caseless but result isn't. case will depend on lookbehind and lookahead
				if (prevDud || !prevCap) {
					output += newStr.toLocaleLowerCase();
					prevCap = false;
				}
				else {
					var next = " ";
					if (location + len < src.length)
						next = src.substr(location + len, 1);

					if (next != next.toLocaleUpperCase() && next == next.toLocaleLowerCase() ) {
						//next is lowercase (and not caseless)
						output += newStr.toLocaleLowerCase();
					}
					else if (next == next.toLocaleUpperCase() && next != next.toLocaleLowerCase() ) {
						// next is uppercase (and not caseless)
						output += newStr.toLocaleUpperCase();
					}
					else {
						// next is caseless. output case determined by the case of output[length - 2]
						var pprevCh = output.length == 1 ? null : output.substr(output.length - 2, 1);
						var pprevDud = !pprevCh || !ToCyrillic.getTranslitString(pprevCh);
						if (!pprevDud && (pprevCh == pprevCh.toLocaleUpperCase())) {
							//pre-prev is in upper case. output is also uppercase
							output += newStr.toLocaleUpperCase();
						}
						else {
						    output += newStr.toLocaleLowerCase();
						}
						
					}
				}
					
			}
			else if ((sub.toLocaleLowerCase() == sub.toLocaleUpperCase()) && (arr.length < 2 || !arr[1])) {
				// literal treatment of newStr - source is caseless, no guessing
				output += newStr;
			}
			else if (sub != sub.toLocaleLowerCase()) {
				// sub not all-lowercase
				
				if (newStr.length > 1 && sub != sub.toLocaleUpperCase()) {
					// capitalize first letter of newStr
					output += newStr.substr(0, 1).toLocaleUpperCase() + newStr.substr(1).toLocaleLowerCase();
				}
				else {
					output += newStr.toLocaleUpperCase();
				}
			}
			else {
				// sub is lowercase
			    output += newStr.toLocaleLowerCase();
			}
			location += len;
		}
	}
	
	return output;
},

splitHtmlString: function(string) {
	var re = /<[\/]?[!A-Z][^>]*>/ig;
	var result = new Array();
	var lastIndex = 0;
	var arr = null;
	while ( (arr = re.exec(string)) != null) {
		result[result.length] = string.substring(lastIndex, arr.index);
		result[result.length] = string.substring(arr.index, re.lastIndex);
		lastIndex = re.lastIndex;
	}
	result[result.length] = string.substr(lastIndex);
	
	return result;
},

/* convert cyrillic to translit using to_translit -- similar to from_translit.... */
to_translit_ext: function(src, skipHtml) {
	return ToCyrillic.convertWithSkip(src, skipHtml, ToCyrillic.to_translit);
},

/* convert translit to cyrillic (using ToCyrillic.to_cyrillic above) */
to_cyrillic_ext: function (src, skipHtml) {
	return ToCyrillic.convertWithSkip(src, skipHtml, ToCyrillic.to_cyrillic);
},

convertWithSkip: function(src, skipHtml, converter) {
    if (src == "" || src == null)
        return src;
    if (!skipHtml)
        return converter(src);
    else {
        var arr = ToCyrillic.splitHtmlString(src);
        
        for (var i = 0; i < arr.length; i++) {
            if ( (i % 2) == 0)
                arr[i] = converter(arr[i]);
        }

        return arr.join("");
    }
},

translitHash : undefined,

initTranslit: function () {
	if (ToCyrillic.translitHash == undefined) {
		ToCyrillic.translitHash = new Array();

		for (var i = 0; i < ToCyrillic.conversionTable.length; i++) {
			var ch = ToCyrillic.conversionTable[i][1];
			ToCyrillic.maxCyrLength = Math.max(ToCyrillic.maxCyrLength, ch.length);
			// if the translit string is not caseless, convert cyr string to upper case
			// otherwise maintain its case
			if (ToCyrillic.conversionTable[i][0].toLocaleUpperCase() != ToCyrillic.conversionTable[i][0].toLocaleLowerCase())
				ch = ch.toLocaleUpperCase();
				
			if (ToCyrillic.translitHash[ch] == undefined)
				ToCyrillic.translitHash[ch] = ToCyrillic.conversionTable[i][0];
		}
	}
},

getTranslitString: function(ch) {
	ToCyrillic.initTranslit();
		
	var value = ToCyrillic.translitHash[ch];
	if (value == undefined)
		value = ToCyrillic.translitHash[ch.toLocaleUpperCase()];
	return value;
},

/* convert cyrillic to translit */
to_translit: function (src) {
	if (src == undefined || src == "" || src == null)
		return src;
	
	//force initTranslit to get the value of maxCyrLength
	ToCyrillic.getTranslitString("");
	
	var output = new String();
	var loc = 0;
	while (loc < src.length) {
	//for (var i = 0; i < src.length; i++) {
		var len = Math.min(ToCyrillic.maxCyrLength, src.length - loc);
		var value = undefined;
		var str = undefined;
		
		while (len > 0) {
			str = src.substr(loc, len);
			value = ToCyrillic.getTranslitString(str);
			if (value == undefined)
				len--;
			else
				break;			
		}
		//var ch = src.substr(i, 1);
		//var value = ToCyrillic.getTranslitString(ch);
		if (value != undefined) {
			if (str == str.toLocaleLowerCase()) {
				output += value.toLocaleLowerCase();
			}
			else if (str != str.toLocaleUpperCase() && value.length > 1) {
				// neither upper nor lower - upcase first letter and be done
				output += value.substr(0, 1).toLocaleUpperCase() + value.substr(1).toLocaleLowerCase();
			}
			else {
				// str is all upcase
			
				var prev = loc == 0 ? null : src.substr(loc - value.length, 1);
				var next = loc == src.length - str.length ? null : src.substr(loc + str.length, 1);
				if ( value.length == 1 || str.length > 1 ||
				   (prev && prev == prev.toLocaleUpperCase()) ||
				   (next && next == next.toLocaleUpperCase())) {
				     // completely capitalize
				     output += value.toLocaleUpperCase();
				}
				else {
					 // capitalize first letter
					 output += value.substr(0, 1).toLocaleUpperCase() + value.substr(1).toLocaleLowerCase();
				}
			}
		}
		else
			output += str;
			
		loc += str.length;
	}

	return output;
},

getNode: function () {
   
    var node = document.commandDispatcher.focusedElement;
    if (node == null) {
		if (document.commandDispatcher.focusedWindow) {
		
			if (document.commandDispatcher.focusedWindow.document) { 
				// lets hope this is the editor content window
				// I don't know how to get to the editor from it, so....
				
				var editors = document.getElementsByTagName("editor");
				for (var i = 0; i < editors.length; i++)
					if (editors[i].contentWindow == document.commandDispatcher.focusedWindow)
						return editors[i];
			
				//return document.commandDispatcher.focusedWindow; 
				
			}
			
			if (document.commandDispatcher.focusedWindow.frameElement &&
			    document.commandDispatcher.focusedWindow.frameElement.contentDocument &&
			    document.commandDispatcher.focusedWindow.frameElement.contentDocument.designMode == "on")
			    return document.commandDispatcher.focusedWindow.frameElement; // midas rich text editor in an iframe
			 
		}
       
    } else {

		var nodeLocalName = node.localName.toLocaleUpperCase();

		if ((nodeLocalName == "TEXTAREA") || (nodeLocalName == "INPUT" && (node.type == "text" || node.type == "file")) || nodeLocalName == "TEXTBOX") {
			if (!(node.disabled || node.readOnly))
				return node;
		} 
        
	}
	return null;
},


onCyrillize : function () {

  var node = ToCyrillic.getNode();
  if (node != null || !ToCyrillic.isSelectionEmpty(ToCyrillic.getSelection(null))) {
	if (node == null || ToCyrillic.isNodeEditor(node)) {
		ToCyrillic.convertSelection(ToCyrillic.getSelection(node), ToCyrillic.to_cyrillic);
	}
	else {
		var str = node.value.substring(node.selectionStart, node.selectionEnd);
		str = ToCyrillic.to_cyrillic_ext(str, true);
		ToCyrillic.replaceValue(node, str);
	}
	
  }

},

onTranslit: function () {

  var node = ToCyrillic.getNode();
  if (node != null || !ToCyrillic.isSelectionEmpty(ToCyrillic.getSelection(null))) {
	
	if (node == null || ToCyrillic.isNodeEditor(node)) {
		ToCyrillic.convertSelection(ToCyrillic.getSelection(node), ToCyrillic.to_translit);
	}
	else {
		var str = node.value.substring(node.selectionStart, node.selectionEnd);
		str = ToCyrillic.to_translit(str);
		ToCyrillic.replaceValue(node, str);
	}

  }
},

replaceValue: function(node, value) {
	if (ToCyrillic.isNodeEditor(node)) {
		//ToCyrillic.insertText(node, value);
		return; // we don't do that!
	}
	else {
		var scrollTop = node.scrollTop;
		var cursorLoc =  node.selectionStart;
		node.value = node.value.substring(0, node.selectionStart) + value + 
                node.value.substring(node.selectionEnd, node.value.length);
		node.scrollTop = scrollTop;
		node.selectionStart = cursorLoc + value.length;
		node.selectionEnd = cursorLoc + value.length;
	}
},


RangeConversionState: function(range, converter) {
	this.range = range;
	this.convert = converter;
	this.started = false;
	this.finished = false;
	this.toString = function() {
		return "started : " + this.started + ", finished: " + this.finished;
	};
},

convertRangeNode: function(node, state) {
	if (state.started && state.finished)
		return;

	if (!state.started && 
		( ( (state.range.startContainer.nodeType == node.TEXT_NODE || 
			 state.range.startContainer.nodeType == node.PROCESSING_INSTRUCTION_NODE || 
			 state.range.startContainer.nodeType == node.COMMENT_NODE	)
		    && node == state.range.startContainer) 
			||
		  ( state.range.startContainer.childNodes && node == state.range.startContainer.childNodes[state.range.startOffset])
		))
		state.started = true;

	if (node.nodeType == node.TEXT_NODE || node.nodeType == node.PROCESSING_INSTRUCTION_NODE || node.nodeType == node.COMMENT_NODE) {
		if (state.started && !state.finished) {
			// convert text
			var start = (node == state.range.startContainer) ? state.range.startOffset : 0;
			var end   = (node == state.range.endContainer) ? state.range.endOffset : node.nodeValue.length;
			var remainder = (node == state.range.endContainer) ? node.nodeValue.length - state.range.endOffset : 0;
			var convertedValue = node.nodeValue.substring(0, start) + state.convert(node.nodeValue.substring(start, end)) + node.nodeValue.substr(end);

			node.nodeValue = convertedValue;
			
			if (node == state.range.endContainer) {
				state.range.setEnd(node, node.nodeValue.length - remainder);
			}
			if (node == state.range.startContainer) {
				state.range.setStart(node, start);
			}
		}
	}
	else if (node.childNodes)
		// walk the tree
		for (var i = 0; i < node.childNodes.length; i++) {
			ToCyrillic.convertRangeNode(node.childNodes[i], state);
			if (state.started && state.finished)
				break;
		}
		
	if (!state.finished && 
		( ((state.range.endContainer.nodeType == node.TEXT_NODE || 
			 state.range.endContainer.nodeType == node.PROCESSING_INSTRUCTION_NODE || 
			 state.range.endContainer.nodeType == node.COMMENT_NODE	)
		     && node == state.range.endContainer) 
			||
		  ( (state.range.endContainer.childNodes.length > 0) && node == state.range.endContainer.childNodes[state.range.endOffset - 1])
		))
		state.finished = true;
		
},

collapseSelection: function() {
	var node = ToCyrillic.getNode();
	if (node != null || !ToCyrillic.isSelectionEmpty(ToCyrillic.getSelection(null))) {
		if (node == null || ToCyrillic.isNodeEditor(node)) {
			ToCyrillic.getSelection(node).collapseToEnd();
		}	
	}
},

convertSelection: function(selection, converter) {
	if (selection == null) return;
	for(var i = 0; i < selection.rangeCount; i++) {
		ToCyrillic.convertRangeNode(selection.getRangeAt(i).commonAncestorContainer, new ToCyrillic.RangeConversionState(selection.getRangeAt(i), converter));
	}
	
	// calling selection.collapseToEnd() causes a crash when selection ends at is at the end of a text node
	// however, with a timeout it seems to work. Bug in gecko?
	setTimeout("ToCyrillic.collapseSelection();", 20);
},


// event handlers
toCyrillicUnload: function (event) {
	
	var document = event.originalTarget;
	//scan states, remove
	for (i in ToCyrillic.stateHash) {
		if (ToCyrillic.stateHash[i].node.ownerDocument == document) {
			delete(ToCyrillic.stateHash[i]);
		}
	}
	

	if (ToCyrillic) {

		if (event.eventPhase == 2 && event.currentTarget == window) {
			ToCyrillic.prefObserver.unregister();
			//ToCyrillic.logMessage("ToCyrillic unloaded");
		}
	}

},


onPopup: function () {
    var node = ToCyrillic.getNode();
    var selEmpty = ToCyrillic.isSelectionEmpty(ToCyrillic.getSelection(null));

    item = document.getElementById("context_toc_tocyrillic");
    if (item != null) 
	    item.hidden = (node == null && selEmpty); 
    item = document.getElementById("context_toc_totranslit");
    if (item != null) 
	    item.hidden = (node == null && selEmpty); 
    item = document.getElementById("context_toc_separator");
    if (item != null) 
	    item.hidden = (node == null && selEmpty); 
    item = document.getElementById("menu_toc_tocyrillic");
    if (item != null) 
	    item.hidden = (node == null && selEmpty); 
    item = document.getElementById("menu_toc_totranslit");
    if (item != null) 
	    item.hidden = (node == null && selEmpty); 
    item = document.getElementById("menu_toc_separator");
    if (item != null) 
    	    item.hidden = (node == null && selEmpty); 
    
    item = document.getElementById("context_toc_togglemode");
    if (item != null) {
		item.hidden = (node == null);
		if (!item.hidden) {
			item.setAttribute("checked", ToCyrillic.isCyrillicMode(node));
		}
    }
    item = document.getElementById("menu_toc_togglemode");
    if (item != null) {
		item.hidden = (node == null);
		if (!item.hidden) {
			item.setAttribute("checked", ToCyrillic.isCyrillicMode(node));
		}
    }
    
},

prefObserver: {
	pref : undefined,
	
	register: function(prefBranch) {
		this.pref = prefBranch.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
		this.pref.addObserver("", this, false);
	},
	
	unregister: function() {
		if (this.pref)
			this.pref.removeObserver("", this);
	},
	
	observe: function(aSubject, aTopic, aData) {
		if(aTopic != "nsPref:changed") return;
	
		if (!ToCyrillic) return;
		
		aSubject.QueryInterface(Components.interfaces.nsIPrefBranch);
		//ToCyrillic.logMessage("observed change in " + aData);
	
		// aSubject is the nsIPrefBranch we're observing
		// aData is the name of the pref that's been changed (relative to aSubject)
		if (aData.search(/shortcuts/i) >= 0){
			ToCyrillic.loadPreferredShortcuts(aSubject);
		}
		else if (aData.search(/labels/i) >= 0) {
			ToCyrillic.loadPreferredMenuLabels(aSubject);
		}
		else if (aData == "layout" || ((aData.search(/layouts/i) >= 0) && (aData.indexOf(aSubject.getCharPref("layout")) >= 0))) {
			ToCyrillic.loadPreferredLayout(aSubject)
		}
	}
},

toCyrillicInit: function (event) {
	var pref = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch("extensions.tocyrillic.");
	
	try {
		ToCyrillic.loadPreferredLayout(pref);
		ToCyrillic.loadPreferredShortcuts(pref);
		ToCyrillic.loadPreferredMenuLabels(pref);
	} 
	catch (e) {
		ToCyrillic.logMessage(e.message);
	}
	
	ToCyrillic.prefObserver.register(pref);
	
	//todo: set up prefs for highlight style and load them here --- need this?

    if (window)
		window.addEventListener("unload", ToCyrillic.toCyrillicUnload, true);
    
    // attach onpopup events to hide or disable tocyrillic menu items when necessary
    if (document.getElementById("contentAreaContextMenu")){
        document.getElementById("contentAreaContextMenu").addEventListener("popupshowing", ToCyrillic.onPopup, false);
    }
    if (document.getElementById("menu_EditPopup")){
        document.getElementById("menu_EditPopup").addEventListener("popupshowing", ToCyrillic.onPopup, false);
    }
    // add menu for bookmarks manager & view source
    var menu = document.getElementById("menu_edit");
    if (menu) {
        menu.addEventListener("popupshowing", ToCyrillic.onPopup, false);
		menu = menu.getElementsByTagName("menupopup")[0];
		menu.appendChild(document.getElementById("menu_toc_separator"));
		menu.appendChild(document.getElementById("menu_toc_tocyrillic"));
        menu.appendChild(document.getElementById("menu_toc_totranslit"));
        menu.appendChild(document.getElementById("menu_toc_togglemode"));
    }

    // add menu in thunderbird
    if (document.getElementById("menu_Edit")){
        document.getElementById("menu_Edit").addEventListener("popupshowing", ToCyrillic.onPopup, false);
        document.getElementById("menu_Edit").firstChild.appendChild(document.getElementById("menu_toc_separator"));
        document.getElementById("menu_Edit").firstChild.appendChild(document.getElementById("menu_toc_tocyrillic"));
        document.getElementById("menu_Edit").firstChild.appendChild(document.getElementById("menu_toc_totranslit"));
        document.getElementById("menu_Edit").firstChild.appendChild(document.getElementById("menu_toc_togglemode"));
	
    }
    if (document.getElementById("messagePaneContext")){
        document.getElementById("messagePaneContext").addEventListener("popupshowing", ToCyrillic.onPopup,false);    
    }
    if (document.getElementById("msgComposeContext")){
        document.getElementById("msgComposeContext").addEventListener("popupshowing", ToCyrillic.onPopup,false);    
    }
    
    //adjustment for dialogs
    if( document.firstChild.nodeName.toLocaleUpperCase() == "DIALOG") {
		var dialog = document.firstChild;
		var keysets = document.getElementsByTagName("keyset");
		for (var i = 0; i < keysets.length; i++)
			dialog.appendChild(keysets[i]);
    }
    
},

// ---- translit on the fly ----- 


isCyrillicMode: function (node) {
	return (ToCyrillic.stateHash[node] != undefined);
},

toggleMode: function () {
	// if state exists, delete it, remove event listener
	// if state does not exist, add event listener
	// flash new status

	var node = ToCyrillic.getNode();
	if (node == null) return;
	
	var msg = "";
	if (ToCyrillic.isCyrillicMode(node)) {
		if (node.contentDocument)
			node.contentDocument.documentElement.removeEventListener("keypress", ToCyrillic.translitOnKey, false);
		else
			node.removeEventListener("keypress", ToCyrillic.translitOnKey, false);
		if (ToCyrillic.isNodeEditor(node)) 
			node.style.border = ToCyrillic.stateHash[node].outline;
		else 
			node.style.outline = ToCyrillic.stateHash[node].outline;
		delete ToCyrillic.stateHash[node];
	}
	else {
		const style = "dotted 1px blue";
		if (node.contentDocument)
			node.contentDocument.documentElement.addEventListener("keypress", ToCyrillic.translitOnKey, false);
		else
			node.addEventListener("keypress", ToCyrillic.translitOnKey, false);
		ToCyrillic.stateHash[node] = new ToCyrillic.StateObject(node);
		if (ToCyrillic.isNodeEditor(node)) 
			node.style.border = style;
		else
			node.style.outline = style;
	}
},






positionEquals: function (other) {
	if (this.inEditor != other.inEditor)
		return false;
	if (this.inEditor) { 
		return (this.focusNode == other.focusNode && this.focusOffset == other.focusOffset);
	} else {
		return this.position == other.position;
	}
},

isNodeEditor: function (node) {
  return ((node.getEditor != undefined) || (node.contentDocument != undefined));
},

isSelectionEmpty: function(selection) {
	return (selection == undefined || selection == null || selection.toString() == "");
},
	
//selection in editor or midas or global
getSelection: function (node) {
  if (node == null) {
	if (document.commandDispatcher.focusedWindow && 	document.commandDispatcher.focusedWindow.getSelection) {
		return document.commandDispatcher.focusedWindow.getSelection();
	}
	else
		return null;
  } 
  else {	
	  return node.getSelection ? node.getSelection() : node.contentWindow.getSelection();
  }
},

// object for tracking position in text boxes and editors
TocPosition: function (node) {
	this.inEditor = ToCyrillic.isNodeEditor(node);
	if (this.inEditor) {
		var selection = ToCyrillic.getSelection(node);
		this.focusNode = selection.focusNode;
		this.focusOffset = selection.focusOffset;
	}
	else {
		this.position = node.selectionStart;
	}
	this.equals = ToCyrillic.positionEquals;
},


resetState: function () {
	this.position = new ToCyrillic.TocPosition(this.node);
	this.transBuffer = "";
	this.cyrBuffer = "";
},

StateObject: function (node) {
	this.node = node;
	this.reset = ToCyrillic.resetState;
	this.cyrBuffer = "";
	this.transBuffer = "";
	this.position = new ToCyrillic.TocPosition(node);
	if (ToCyrillic.isNodeEditor(this.node))
		this.outline = node.style.border;
	else
	    this.outline = node.style.outline;
},


stateHash : new Array(),

translitOnKey: function (event) {
	if ((event.keyCode == 255 && event.charCode > 0) || event.keyCode == 8) {
		
		//alert("evt1");
		
		if (event.target.nodeName == "HTML") {
			// strange hack - without this editor does not do anything with this event
			var s = "";
			for (var i in event) {
				if (("" + i) != ("" + i).toLocaleUpperCase()) {
					s += i + " = " + event[i] + "\n";
				}
			}
		}
			//alert(s);
		
	  return;
	}
	//alert("evt2");

	var node = ToCyrillic.getNode();
	//var node = event.target;
	
	
	// initialize state
	var state = ToCyrillic.stateHash[node];
	if (state == null) {
		//alert("no state in hash! please alert the extension developer"); // an assertion
		state = new ToCyrillic.StateObject(node);
		ToCyrillic.stateHash[node] = state;
	}
	
	if (event.charCode > 0 && !event.ctrlKey && !event.altKey && !event.metaKey) {
		//ToCyrillic.logMessage("event.which: " + event.which + ", event.keyCode = " + event.keyCode + ", event.charCode = " + event.charCode);
		var c = String.fromCharCode(event.charCode);

		// process input
		var result = ToCyrillic.processTranslit(state, c);

		// finish up
		//if (c != result.out || result.replace != 0) {
		  event.preventDefault();
		  //ToCyrillic.logMessage("result.out: " + result.out + ", result.replace: " + result.replace);

		  var tosend = new Array(result.replace + result.out.length);
		  for (var i = 0; i < result.replace; i++)
			tosend[i] = 8;
		  for(var i = result.replace; i < tosend.length; i++) {
		    tosend[i] = result.out.charCodeAt(i - result.replace);
		  }
		  
		  
		  for (var i = 0; i < tosend.length; i++) {
			  var evt = document.createEvent("KeyEvents");
			  if (tosend[i] == 8)
				  evt.initKeyEvent(event.type, event.canBubble, event.cancelable, event.view, false, false, false, false, 8, 0);
			  else
				// use keyCode 255 as an indicator that the event should be ignored
			  	evt.initKeyEvent(event.type, event.canBubble, event.cancelable, event.view, false, false, false, false, 255, tosend[i]);
		    //alert(event.target.tagName);
			//result.out.charCodeAt(result.out.length - 1));

			if (event.target.tagName == "HTML" & ToCyrillic.newGecko)
    			event.target.ownerDocument.dispatchEvent(evt); 
    		else
			     event.target.dispatchEvent(evt);
		  }

		  state.position = new ToCyrillic.TocPosition(node);
		  
		//}
	}
},

TranslitResult: function () {
	this.out = "";
	this.replace = 0;
},

processTranslit: function (state, c) {
	// reset state if position changed
	if (!state.position.equals(new ToCyrillic.TocPosition(state.node)))
		state.reset();
		
	var result = new ToCyrillic.TranslitResult();
	
	// initial backbuffer. Add to it as characters are converted
	
	var backbuffer = ToCyrillic.getBackBuffer(state.node, state.cyrBuffer.length, 2 * ToCyrillic.maxLatLength);
	//ToCyrillic.logMessage("backbuffer: " + backbuffer);

	var chunks = new Array(0);
	
	state.transBuffer = state.transBuffer + c;

	var str = ToCyrillic.to_cyrillic(state.transBuffer, backbuffer, chunks);
	//ToCyrillic.logMessage("str: " + str);

	// remove backbuffer from output
	str = str.substr(backbuffer.length);
	result.out = str; 
	/* str is now left alone - it has the output matching contents of chunks and 
	   will be used to reinitialize backbuffers, along with chunks and state.transBuffer
	*/
	
	// get the difference between state.cyrBuffer and output
	for (var i = 0; i < Math.min(state.cyrBuffer.length, result.out.length); i++) {
		if (state.cyrBuffer.substr(i, 1) != result.out.substr(i, 1)) {
			result.replace = state.cyrBuffer.length - i;
			result.out = result.out.substr(i);
			break;
		}
	}
	if (result.replace == 0) {
		result.out = result.out.substr(Math.min(state.cyrBuffer.length, result.out.length));
	}
	//ToCyrillic.logMessage("chunks " + chunks);
	// update state: backbuffer, bufferArray
	
        /* //removing all reset stuff - no need to reset on any character, just make sure to push out whatever needs to be pushed out
	//todo : allow a character that does not get converted by itself but is part of a convertible sequence to
	// not reset state
	
	// determine if state needs to be reset.
	// reset state only if the sum of all unconverted characters in chunks is >= than maxLatLength
	// so that things like jj could be understood even if j isn't.
	var needReset = false;
	var cCnt = chunks.length - 1;
	var noncon = "";
	while (cCnt >= 0 && !chunks[cCnt][1]) { // go backwards through chunks, add up non-converted pieces
		noncon = chunks[cCnt][0] + noncon;
		cCnt--;
	}
	//ToCyrillic.logMessage("noncon " + noncon);

	if (noncon.length >= ToCyrillic.maxLatLength)
		needReset = true; // no need to check anything
	else if (noncon.length > 0){
		// check if noncon possibly represents a start of convertable sequence
		noncon = noncon.toLocaleUpperCase();
		var found = false;
		for (var key in ToCyrillic.getConversionHash()) {
			if (key.length >= noncon.length && key.toLocaleUpperCase().indexOf(noncon) == 0) {
				found = true;
				break;
			}
		}
		needReset = !found;
	}
	
	if (needReset)
		state.reset();

        */ //end of no reset part 1
	/*
	if (chunks.length > 0 && chunks[chunks.length - 1][0] == result.out.substr(result.out.length - 1)) {
		// no convertion took place
		
		// reset state
		state.reset();
	}*/
	/*else {*/ // commented out because not doing reset (no reset part 2)
		while (state.transBuffer.length > ToCyrillic.maxLatLength) {
			state.transBuffer = state.transBuffer.substr(chunks[0][0].length);
			// chunks[i][1] evaluates to false if no conversion took place, otherwise holds the length of cyr string
			str = str.substr(chunks[0][1] ? chunks[0][1] : chunks[0][0].length); 
			chunks.shift();
		}
		state.cyrBuffer = str;
	/*}*/ //commented out because not doing reset (no reset part 3)
	
	//ToCyrillic.logMessage("state: transBuffer: " + state.transBuffer + ", cyrBuffer: " + state.cyrBuffer);
	return result;
},


// return count number of characters starting count + offset characters back from current position
getBackBuffer : function (node, offset, count) {
	if (ToCyrillic.isNodeEditor(node)) { //.tagName.toLocaleUpperCase() == "EDITOR") {
		var selection = ToCyrillic.getSelection(node);
		
		if (!selection.focusNode.nodeValue)
			return "";
		
		var result = selection.focusNode.nodeValue.substr(0, selection.focusOffset - offset).substr(-count);
		if (!result)
			result = "";
			
		return result;
	} else {
		return node.value.substring(0, node.selectionStart - offset).substr(-count);
	}
},


// preferences

getUnicodePref: function (prefName,prefBranch) {
    return prefBranch.getComplexValue(prefName, Components.interfaces.nsISupportsString).data;
},

loadPreferredLayout: function(prefBranch) {
	try {
		var layoutName = prefBranch.getCharPref("layout");
	}
	catch (e) {
		ToCyrillic.logMessage("extensions.tocyrillic.layout value not found. Trying default");
		layoutName = "default";
	}

	try {
		var layout = ToCyrillic.getUnicodePref("layouts." + layoutName, prefBranch);
	}
	catch (e) {
		ToCyrillic.logMessage("Could not load conversion table from extensions.tocyrillic.layouts." + layoutName);
	}

	// if it bombs, let it bomb...
	ToCyrillic.conversionTable = eval(layout);
	ToCyrillic.conversionHash = undefined;
	ToCyrillic.translitHash = undefined;
},

setShortcutKey: function(keyString) {
	if (arguments.length < 2) return;
	keyString = keyString.toLocaleLowerCase();
	
	var found = keyString.match(/(vk_[A-Z0-9]+)/i);
	if (!found)
		return;
	var keyCode = found[0];
	var mods = "";
	
	
	keyString = keyString.replace(/ctrl/i, "control");
	var stdmods = new Array("accel", "alt", "control", "meta", "shift");
	for (var i = 0; i < stdmods.length; i++) {
		if (keyString.indexOf(stdmods[i]) >= 0)
			mods += (mods == "" ? "" : ", ") + stdmods[i];
	}
	
	for (var i = 1; i < arguments.length; i++) {
		var element = document.getElementById(arguments[i]);
		if (element) {
			if (keyCode.length == 4)
				element.setAttribute("key", keyCode.substr(3));
			else {
				element.removeAttribute("key");
				element.setAttribute("keycode", keyCode.toLocaleUpperCase());
			}
			element.setAttribute("modifiers", mods);
		}
	}
},

loadPreferredShortcuts: function(prefBranch) {
	var key = prefBranch.getCharPref("shortcuts.tocyrillic");
	if (key)
		ToCyrillic.setShortcutKey(key, "key_toc_tocyrillic");
	
	key = prefBranch.getCharPref("shortcuts.totranslit");
	if (key)
		ToCyrillic.setShortcutKey(key, "key_toc_totranslit");
	
	key = prefBranch.getCharPref("shortcuts.togglemode");
	if (key)
		ToCyrillic.setShortcutKey(key, "key_toc_togglemode");
},

setMenuLabels: function(label) {
	for (var i = 1; i < arguments.length; i++) {
		var element = document.getElementById(arguments[i]);
		if (element) {
			element.label = label;
		}
	}
},

loadPreferredMenuLabels: function(prefBranch) {
	var label = ToCyrillic.getUnicodePref("labels.tocyrillic", prefBranch);
	if (label)
		ToCyrillic.setMenuLabels(label, "context_toc_tocyrillic", "menu_toc_tocyrillic");
		
	label = ToCyrillic.getUnicodePref("labels.totranslit", prefBranch);
	if (label)
		ToCyrillic.setMenuLabels(label, "context_toc_totranslit", "menu_toc_totranslit");

	label = ToCyrillic.getUnicodePref("labels.togglemode", prefBranch);
	if (label)
		ToCyrillic.setMenuLabels(label, "context_toc_togglemode", "menu_toc_togglemode");
	
},

logMessage: function(msg) {
  var consoleService = Components.classes["@mozilla.org/consoleservice;1"]
                                 .getService(Components.interfaces.nsIConsoleService);
  consoleService.logStringMessage("ToCyrillic: " + msg);
}

} // end of ToCyrillic object

// initialization
if (window)
	window.addEventListener("load",ToCyrillic.toCyrillicInit,false);
	
if (ToCyrillic) {
    ToCyrillic.platformVersion = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo).platformVersion.split(/[^0-9]*/);
    ToCyrillic.newGecko = parseInt(ToCyrillic.platformVersion[0]) > 1 || parseInt(ToCyrillic.platformVersion[1]) > 8;
    //window.alert(ToCyrillic.platformVersion);
}
	
//else if (dialog)
//	dialog.addEventListener("load",ToCyrillic.toCyrillicInit,false);


/* todo:
	prefs for changing shortcuts
	prefs for layouts
	pref for style when keyboard mode enabled

	prefs gui
	
	layout table gui

	find out if it is possible to make global overrides, so as not to specify shortcuts in each dialog
	find out if it is possible (and make sense) to toggle mode for all fields at the same time 
*/
 //debug functions
/*
function objToString(obj) {
	var s = "";
	for(var i in obj)
		if ( ("" + i != ("" + i).toLocaleUpperCase()) &&
			  !(obj[i] instanceof Function))
		//if (obj[i] instanceof Function)
		//	s += i + ": function\n";
		//else
			s += i + " = " + obj[i] + "\n";
	return s;
}
*/
